gateway_stripe/urls.py
from django.contrib import admin
from django.urls import path, include
from .views import home_page
from payment.webhook import my_webhook_view

urlpatterns = [
    path('admin/', admin.site.urls),
    path('index/', home_page, name ="home_page"),
    path(r'webhook/', my_webhook_view, name = "my_webhook_view"),
    path(r'secure/', include('payment.urls', namespace='payment'), name ="payment"),

]

payment/urls.py
from django.conf.urls import url
from django.urls import path
from .views import *
app_name='payment'
urlpatterns = [
    path(r'payment_info/', payment_info, name ="payment_info"),
    path(r'payment_detail/<str:pk>/', payment_detail, name ="payment_detail"),
    path(r'checkout/', new_checkout, name ="new_checkout"),
    path(r'new_checkout_process/', new_checkout_process, name ="new_checkout_process"),
]

payment/models.py
from django.db import models
from django.db.models.signals import pre_save
from .stripe import create_product_plan
from django.dispatch import receiver

class Subscription_Plan(models.Model):
	Plan_Name 			= models.CharField(max_length = 30)
	Price 				= models.IntegerField()

	#This Can be stored thrugh Post Signal 
	Product_Plan_ID 	= models.CharField(max_length = 30,null = True, blank = True)
	Product_Price_ID 	= models.CharField(max_length = 30,null = True, blank = True)

	def __str__(self):
		return self.Plan_Name

	# class Payment_Process_Table(models.Model):

 # method for updating

def subscription_pre_save_receiver(sender, instance, **kwargs):
	instance.Product_Plan_ID, instance.Product_Price_ID =  create_product_plan(plan_price = instance.Price, product_name = instance.Plan_Name)
	

pre_save.connect(subscription_pre_save_receiver, sender=Subscription_Plan)

payment_type_choices = [
	("bacs_debit", "bacs_debit"),
	("card","card"),
	("invoice","invoice")
]
payment_status_choices = [
	("In-Progress", "In-Progress"),
	("Succeed","Succeed"),
	("Failed","Failed")
]

class Subcription_Info_Model(models.Model):
	Customer_ID 	= models.CharField(max_length = 30)
	Customer_Email 	= models.EmailField(max_length = 255, unique =True)
	Subscription_ID = models.CharField(max_length = 30, null=True, blank = True)
	is_subscription = models.BooleanField(default = False)
	Invoice_ID = models.CharField(max_length = 30, null=True, blank = True)
	Payment_Type = models.CharField(max_length = 30, choices = payment_type_choices, null=True, blank=True)
	End_Date 		= models.DateTimeField(null = True, blank = True)
	Subscription_Plan =  models.ForeignKey(Subscription_Plan, on_delete=models.CASCADE, null=True, blank=True)
	Payment_Status = models.CharField(max_length = 50,choices= payment_status_choices, default = "In-Progress", null=True, blank=True)
	Payment_Failed_Code = models.CharField(max_length = 50, null=True, blank=True)
	Payment_Failed_Reason = models.CharField(max_length = 50, null=True, blank=True)
	def __str__(self):
		return self.Customer_Email
	
	def is_subsciption(self):
		return self.is_subsciption

	
	def end_date(self):
		return self.End_Date
	
	

gateway_stripe/views.py
from django.shortcuts import render
# Create your views here.

#SIMPLE API WITH FUNCTION AND JSONRESPONSE/PARSER
def home_page(request):
	context = {
		'quote' : "Ceaser Project" 
	}
	return render(request, 'home_page.html', context=context)

payment/views.py
from django.shortcuts import render
from django.views.decorators.csrf import csrf_exempt
import stripe
from gateway_stripe.config import get_stripe_public_key, get_stripe_secret_key
from .models import *
from .stripe import *
from datetime import datetime
import json
# Create your views here.
#stripe listen --forward-to http://localhost:8000/webhook/
STRIPE_SECRET_KEY = "sk_test_51IUDDcIX7H1lFVv1OSjZt7ia68q4pNvMet2RX9eVqi2DHYhV4rZoEcuSDm5MZjyAHR92qk8JRHNdpyTC6EqtZ9ak00DXWemVG8"
@csrf_exempt
def new_checkout(request):
	context = {}
	return render(request, 'new_payment.html', context=context)

@csrf_exempt
def new_checkout_process(request):
	context = {}
	
	# total_price >fetched and calculated from backend table {tax/promotion etc...}
	total_price = 1099.9999999
	amount = int(total_price * 100)
	#quantity fetched from Table: default 1
	quantity = 1

	# fetch plan name from Table
	plan_name = "Premium" 

	stripe.api_key = STRIPE_SECRET_KEY
	checkout_session = stripe.checkout.Session.create(
		payment_method_types=['card','bacs_debit'],
		line_items=[
			{
				'price_data': {
					'currency': 'gbp',
					'unit_amount': amount,
					'product_data': {
						'name': plan_name,
					},
				},
				'quantity': quantity,
			},
			
		],
		payment_intent_data = {
			'setup_future_usage' : 'off_session'
		},
		mode='payment',
		success_url='http://18.132.233.54:8000/subscription',
		cancel_url='http://18.132.233.54:8000/subscription',
	)
	#send 200OK with session id to front end for checkout
	context["session_id"] = checkout_session.id
	context["STRIPE_PUBLISHABLE_KEY"] = get_stripe_public_key()
	return render(request, 'checkout.html', context=context)
	
def payment_token(request):
	token = request.POST.get("token",None)
	payment_type = request.POST.get("payment_type",None)
	#total_price = price * quantity
	#amount = total_price * 100 {for stripe purpose}
	total_price = 75 * 2
	amount = total_price * 100 #{for stripe purpose}
	
	if token and payment_type:
		stripe.api_key = get_stripe_secret_key()
		if payment_type == "card":
			intent = stripe.PaymentIntent.create(
				amount = amount,
				currency = "gbp",
				payment_method_data=dict(
					type="card",
					card=dict(
						token=token
					)
				), 
			)
		elif payment_type == "redirect":
			intent = stripe.PaymentIntent.create(
				amount = amount,
				currency = "gbp",
				payment_method_data=dict(
					type="bacs_debit",
					bacs_debit =dict(
						token=token
					)
				), 
			)

		


def payment_info(request):
	context = {}
	subscriber_obj = Subcription_Info_Model.objects.all()
	context["subscriber_obj"]= subscriber_obj
	return render(request, 'payment_info.html', context = context)

def payment_detail(request, pk):
	context = {}
	subscriber_obj = Subcription_Info_Model.objects.get(Customer_ID = pk)
	#subscriber_obj = Subcription_Info_Model.objects.filter(Customer_ID = pk).update(Payment_Status = "Succeed")
	context['subscriber'] = subscriber_obj
	return render(request, 'payment_detail.html', context = context)

templates/3dsecure.html
{% extends "base.html" %} <!-- should always be the first line of html  -->
{% load static %} <!-- if there any static file is there then must put load static -->


{% block base_head %}
<script src="https://js.stripe.com/v3/"></script>

{% endblock %}	<!-- header block extra css file for only this page -->

{% block content %}

{% csrf_token %}
<div class="container" >
	<div class="row py-3">
        <div class="col-lg-12 col-md-12">
           <div class="container">
              <div id="3ds_result">
              </div>
           </div>
        </div>
    </div>
    <form action="{% url 'payment:payment_info' %}" method="POST" id="hiddenForm">
        
        <button type="submit" style="display: none;"></button>
    </form>
</div>



{% endblock %} <!-- body content of this page -->

{% block js %} 
<script>
function _3dsec(stripe_publishable_key, pi_secret) {
    document.addEventListener("DOMContentLoaded", function(event){
      var stripe = Stripe(stripe_publishable_key);

      stripe.confirmCardPayment(pi_secret).then(function(result) {
        if (result.error) {
          // Display error.message in your UI.
          $("#3ds_result").text("Error!");
          $("#3ds_result").addClass("text-danger");
          window.location.replace("http://127.0.0.1:8000/secure/payment_info/");
        } else {
            // The payment has succeeded. Go to Payment Info.
            var form = document.getElementById("hiddenForm"); 
            form.submit();
        }
      });
    }); // DOMContentLoaded
}
</script>
<script>_3dsec('{{ STRIPE_PUBLISHABLE_KEY }}', '{{pi_secret}}');</script>
 




{% endblock %}

templates/base.html
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="google-signin-client_id" content="509068925538-2o8ld29c6dlg7b91buvr60fvo90mcaql.apps.googleusercontent.com">
    <!-- CSS -->
    {% include "base/css.html"%}
    {% block base_head %}{% endblock %}
 
    <title>Sizer Ecommerce</title>
  </head>
  <body>
      <!-- ======= Header ======= -->
  {% include "base/navbar.html" %}

  
  <div class="container-fluid">
      
      <p>
       {% block content%} {% endblock%}
        
      </p>
    </div>
  </div>
</div>
    
    
  <!-- JS -->  
  <div class="container-fluid mt-0 mr-auto ml-auto px-0"  >
      <div class="row">
        <div class="col-lg-12 col-sm-12 m-0 p-0 order-2" >
          <div class="m-auto alert alert-success" style="height: 15rem" role="alert">
              Footer
          </div>
        </div>  
      </div>
    </div>  
  {% include "base/js.html"%}  
  {% block js%} {% endblock%}
  </body>
</html>

templates/base/css.html
{% load static %}

<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">

<style type="text/css">
body {
  overflow-x: hidden;
  font-family: 'Roboto', sans-serif;
  font-size: 16px;
}

/* Toggle Styles */

#viewport {
  padding-left: 250px;
  -webkit-transition: all 0.5s ease;
  -moz-transition: all 0.5s ease;
  -o-transition: all 0.5s ease;
  transition: all 0.5s ease;
}

#content {
  width: 100%;
  position: relative;
  margin-right: 0;
}

/* Sidebar Styles */

#sidebar {
  z-index: 1000;
  position: fixed;
  left: 250px;
  width: 250px;
  height: 100%;
  margin-left: -250px;
  overflow-y: auto;
  background: #37474F;
  -webkit-transition: all 0.5s ease;
  -moz-transition: all 0.5s ease;
  -o-transition: all 0.5s ease;
  transition: all 0.5s ease;
}

#sidebar header {
  background-color: #263238;
  font-size: 20px;
  line-height: 52px;
  text-align: center;
}

#sidebar header a {
  color: #fff;
  display: block;
  text-decoration: none;
}

#sidebar header a:hover {
  color: #fff;
}

#sidebar .nav{
  
}

#sidebar .nav a{
  background: none;
  border-bottom: 1px solid #455A64;
  color: #CFD8DC;
  font-size: 14px;
  padding: 16px 24px;
}

#sidebar .nav a:hover{
  background: none;
  color: #FFFFFF;
}

#sidebar .nav a i{
  margin-right: 16px;
}



</style>

templates/base/js.html
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
<script src="https://kit.fontawesome.com/c8e64f049c.js" crossorigin="anonymous">
	
</script>

templates/base/navbar.html
<div id="viewport">
  <!-- Sidebar -->
  <div id="sidebar">
    <header>
      <a href="#">My App</a>
    </header>
    <ul class="nav list-group">
      <li >
        <a  class="list-group-item bg-dark" href="#">
           Dashboard
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark" href="#">
          Shortcuts
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark" href="#">
          Overview
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark" href="#">
          Events
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark"  href="#">
         About
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark"  href="#">
          </i> Services
        </a>
      </li>
      <li>
        <a class="list-group-item bg-dark"  href="#">
           Contact
        </a>
      </li>
    </ul>
  </div>
  <!-- Content -->
  <div id="content">
    <nav class="navbar navbar-default">
      <div class="container-fluid bg-dark">
        <ul class="nav navbar-nav navbar-right">
          <li>
            <a href="#"><i class="zmdi zmdi-notifications text-danger"></i>
            </a>
          </li>
          <li><a href="#">Test User</a></li>
        </ul>
      </div>
    </nav>
    

templates/checkout.html
{% extends "base.html" %} <!-- should always be the first line of html  -->
{% load static %} <!-- if there any static file is there then must put load static -->


{% block base_head %}
<script src="https://js.stripe.com/v3/"></script>

{% endblock %}	<!-- header block extra css file for only this page -->

{% block content %}

{% csrf_token %}
<div class="container" >
	<button id="checkout-button" class="form-control">
        Checkout Now
    </button>
</div>



{% endblock %} <!-- body content of this page -->

{% block js %} 
<script>
function _Redirect(stripe_publishable_key, session_id) {
    var stripe = Stripe(stripe_publishable_key);
    var checkoutButton = document.getElementById('checkout-button');

    checkoutButton.addEventListener('click', function() {
        stripe.redirectToCheckout({
            // Make the id field from the Checkout Session creation API response
            // available to this file, so you can provide it as argument here
            // instead of the {{CHECKOUT_SESSION_ID}} placeholder.
            sessionId: session_id
        }).then(function (result) {
            // If `redirectToCheckout` fails due to a browser or network
            // error, display the localized error message to your customer
            // using `result.error.message`.
            alert(result.error.message);
        });
    });
}
</script>
<script>_Redirect('{{ STRIPE_PUBLISHABLE_KEY }}', '{{session_id}}');</script>
 

{% endblock %}

templates/custome_base.html
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="google-signin-client_id" content="509068925538-2o8ld29c6dlg7b91buvr60fvo90mcaql.apps.googleusercontent.com">
    <!-- CSS -->
    {% include "base/css.html"%}
    {% block base_head %}{% endblock %}
 
    <title>Sizer Ecommerce</title>
  </head>
  <body>
      <!-- ======= Header ======= -->
  

  
    
     
        {% block content%} {% endblock%}
  
    
  

    
    
  <!-- JS -->  
    
  {% include "base/js.html"%}  
  {% block js%} {% endblock%}
  </body>
</html>

templates/home_page.html
{% extends "base.html" %} <!-- should always be the first line of html  -->
{% load static %} <!-- if there any static file is there then must put load static -->


{% block base_head %}
<link rel="stylesheet" type="text/css" href='{% static "css/my.css"%}'>
{% endblock %}	<!-- header block extra css file for only this page -->

{% block content %}

<div class="text-center" align="center"><h1>{{quote}}</h1></div>









{% endblock %} <!-- body content of this page -->

templates/new_payment.html
{% extends "custome_base.html" %} <!-- should always be the first line of html  -->
{% load static %} <!-- if there any static file is there then must put load static -->


{% block base_head %}
<script src="https://js.stripe.com/v3/"></script>
<style>    
/* Pen-specific styles */
    * {
    box-sizing: border-box;
    }
    html, body, section, div {
    height: 100%;
    }

    body { 
    /* color: #fff; */
    font-family: sans-serif;
    font-size: 1.25rem;
    line-height: 150%;
    text-align: center;
    /* text-shadow: 0 2px 2px #b6701e; */
    }

    section {
    width: 100%;
    }

    article {
    position: relative;
    top: 50%;
    left: 50%;
    padding: 1rem;
    text-align: center;
    transform: translate(-50%, -50%);
    }

    h2 {
    font-size: 1.75rem;
    margin: auto;
    margin-bottom: 3rem;
    }

    /* Pattern styles */
    .left-half {
    background-color: inherit;
    float: left;
    width: 50%;
    }
    .right-half {
    background-color: inherit;
    float: left;
    width: 50%;
    }

    .centered {
        position: fixed;
        top: 50%;
        left: 50%;
        /* bring your own prefixes */
        transform: translate(-50%, -50%);
        }
</style>
{% endblock %}	<!-- header block extra css file for only this page -->

{% block content %}

{% csrf_token %}
    <section class="container centered">
        <div class="left-half">
            <article>
                <div class="row">
                    <h2>Checkout Item</h2>
                </div>
                <div class="row" >
                    <div class="container">
                        <h4>Cart <span class="price" style="color:black"><i class="fa fa-shopping-cart"></i> <b>4</b></span></h4>
                        <p><a href="#">Product</a> <span id="price" class="price">75 gbp</span></p>
                        <p>Quantity <span class="price">
                            2
                        </span></p>
                        <hr>
                        <p>Total <span id="total" class="price" style="color:black"><b>30 gbp</b></span></p>
                      </div>
                </div>
            </article>
        </div>
        <div class="right-half">
            <article>
                <div class="row">
                    <h2>Payment Checkout</h2>
                </div>
                <div class="row" >
                    <form  action="{% url 'payment:new_checkout_process' %} " method="post" id="payment-form" class="form-control">
                        <div id="card-element" style="height: 30px;">
                            
                        </div>
                        <div id="card-error" role="alert" style="height: 30px;" >
                            
                        </div>
                        <div class="row">
                            <div class="col">
                                <label for="invoice">Pay by Invoice</label>
                                <input  id="" type="radio" name="payment_type"  value="invoice" class="form-control"><br>
                            </div>
                            <div class="col">
                                <label for="redirect">Bank Redirect</label>
                                <input  id="" type="radio" name="payment_type"  value="redirect" class="form-control"><br>
                            </div>
                            <div class="col">
                                <label for="card">Pay by Card</label>
                                <input id="payment_type"  type="radio" name="payment_type"  value="card" class="form-control"><br>
                            </div>
                            
                        </div>
                        
                        <div class="col">
                            <button id="pay" type="submit">Checkout</button>
                        </div>
                        
                    </form>
                </div>
            </article>
        </div>
    </section>


{% endblock %} <!-- body content of this page -->

{% block js %} 

<script>
    function calculate(){
        var price = document.getElementById("price").innerHTML;
        var quantity = document.getElementById("quantity").value;
        var total = int(quantity) * int(price)
        var total_price = "$" + String(total);
        document.getElementById("total").innerHTML ="<b>"+ total_price +"</b>"
    }
</script>

<script>
    function card1(stripe_publishable_key) {
        document.addEventListener("DOMContentLoaded", function(event){
            var stripe= Stripe(stripe_publishable_key);
            var elements = stripe.elements();
            var card = elements.create('card', {
                iconStyle: 'solid',
                style: {
                  base: {
                    color: '#303238',
                    fontSize: '16px',
                    fontFamily: '"Open Sans", sans-serif',
                    fontSmoothing: 'antialiased',
                    '::placeholder': {
                      color: '#CFD7DF',
                    },
                  },
                  invalid: {
                    iconColor: '#FFC7EE',
                    color: '#FFC7EE',
                  },
                },
              });
    
            
            card.mount('#card-element');
            
            var form= document.getElementById('payment-form');
            var btn= document.getElementById('pay');
            //Handle validation error
            card.addEventListener('change', function(event){
                
                var displayError = document.getElementById('card-error');
                if(event.eroor){
                    displayError.textContent = event.error.message;
                }else{
                    displayError.textContent = '';
                }
            });
            
            btn.addEventListener('click', function(event){
    
                event.preventDefault();
    
                stripe.createToken(card).then(function(result){
                    if(result.error){
                        
                        var errorElement = document.getElementById('card-error');
                        errorElement.textContent = result.error.message
    
                    }else{
                        
                        //Create Payment Method
                        stripe.createPaymentMethod({
                            type: 'card',
                            card: card,
                            /*billing_details:{
                                email : customer_email,
                            },*/
                        }).then(function(payment_method_result){
                            if(payment_method_result.error){
                            var errorElement = document.getElementById('card-error');
                            errorElement.textContent = payment_method_result.error.message;
                            window.location.replace("http://127.0.0.1:8000/secure/payment_info/");
                            }else{
                                alert("Redirecting")
                                var form = document.getElementById('payment-form')
                                var hiddenInput= document.createElement('input')
    
                                hiddenInput.setAttribute('type', 'hidden');
                                hiddenInput.setAttribute('name','payment_method_id' );
                                hiddenInput.setAttribute('value', payment_method_result.paymentMethod.id);
                                form.appendChild(hiddenInput);
                                form.submit()
                            }
                        })
                    }
                });
    
            });
    
    
        });
        
    
    }
    </script>
    
    <script>
    //card1('pk_test_51IUDDcIX7H1lFVv1YPbRxq4o0SAHiZrI6SMCI65E5bNqG3vRWB12gmwtZbZFcJ9EBedhdpytP1HKMK88Nq9DEig600pS3hnGeA');
    
    </script>
{% endblock %} 

templates/payment_info.html
{% extends "base.html" %} <!-- should always be the first line of html  -->
{% load static %} <!-- if there any static file is there then must put load static -->


{% block base_head %}
<link rel="stylesheet" type="text/css" href='{% static "css/my.css"%}'>
{% endblock %}	<!-- header block extra css file for only this page -->

{% block content %}

{% csrf_token %}
<div class="">
	
	
	<table>
		<table class="table">
		  <thead class="thead-dark">
		    <tr>
		      <th scope="col">Customer ID</th>
			  <th scope="col">Payment Type</th>
		      <th scope="col">Plan Name</th>
		    </tr>
		  </thead>
		  <tbody>
		  	{% for subscriber in subscriber_obj %}
		    <tr>
		      	<th>
					<a href="{% url 'payment:payment_detail' pk=subscriber.Customer_ID %}">
					{{subscriber.Customer_ID}}</th>
					</a>
				
				<th>{{subscriber.Payment_Type}}</th>
				
				<th>{{subscriber.Subscription_Plan.Plan_Name}}</th>
		   
		    </tr>
		    {% endfor %}
	</table>
</div>



{% endblock %} <!-- body content of this page -->